function [S] = get_class_similarity_l2norm(modtypes,lambda)

if ~exist('modtypes', 'var')
  modtypes = {"BPSK","QPSK","8PSK","QAM16","QAM64","QAM128"};
end

if ~exist('lambda', 'var')
  lambda = 1;
  % lambda = 0.005;
end

for i = 1:length(modtypes)
  for j = i:length(modtypes)

    % NLEN = 512;

    % group 1

    modname = modtypes{i};
    M = get_modulation_order(modname);
    symbols = [0:M-1];
    NLEN = M;

    assert(mod(NLEN,numel(symbols))==0)
    data = repmat(symbols', [NLEN/numel(symbols), 1]);
    data = data(randperm(length(data)));

    R1 = gen_symbols_amc2(modname, -1, data, false, 0);
    % R1 = normalize_signals(R1,4);

    % group 2

    modname = modtypes{j};
    M = get_modulation_order(modname);
    symbols = [0:M-1];
    NLEN = M;

    assert(mod(NLEN,numel(symbols))==0)
    data = repmat(symbols', [NLEN/numel(symbols), 1]);
    data = data(randperm(length(data)));

    R2 = gen_symbols_amc2(modname, -1, data, false, 0);
    % R2 = normalize_signals(R2,4);

    % hold on; grid on;
    % scatter(real(R1),imag(R1),30,'filled');
    % scatter(real(R2),imag(R2),30,'filled');

    X1 = [real(R1), imag(R1)];
    X2 = [real(R2), imag(R2)];

    D12 = my_pdist(X1,X2) / size(X1,1);
    D21 = my_pdist(X2,X1) / size(X2,1);


    L(i,j) = D12;
    L(j,i) = D21;

    % fprintf('%d-%d dist %.4f :: %d-%d dist %.4f \n',i,j,L(i,j),j,i,L(j,i));

  end  %  ./ for j
end  %  ./ for i


S1 = 1 ./ exp(lambda.*L);

S2 = (S1 + S1')./2;

% S2 = zeros(size(S1));
% for i = 1:length(modtypes)
%   for j = 1:i
%     S2(i,j) = 2 / ((1/(S1(i,j)+eps) + 1/(S1(j,i)+eps))+eps);
%     S2(j,i) = S2(i,j);
%   end
% end

S = S2;