function [patches, y4patcthes, patchIdx] = extract_patches(PATCH_SIZE, X, varargin)

N_INSTANCE = size(X,1);
N_SAMPLE = size(X,2);
assert (N_SAMPLE > PATCH_SIZE)

numvarargs = length(varargin);
optargs = {ones(N_INSTANCE,1)};
optargs(1:numvarargs) = varargin;
[Y] = optargs{:};

assert (size(X,1) == size(Y,1))

N_INSTANCE_PER = N_SAMPLE - PATCH_SIZE + 1;
patches = zeros(N_INSTANCE_PER*N_INSTANCE, PATCH_SIZE);
y4patcthes = zeros(N_INSTANCE_PER*N_INSTANCE, 1);
patchIdx = zeros(N_INSTANCE_PER*N_INSTANCE, 1);
for i = [1:N_INSTANCE]
  patch = im2col(X(i,:),[1 PATCH_SIZE]);
  rr = [(i-1)*N_INSTANCE_PER + 1:i*N_INSTANCE_PER];
  patches(rr,:) = patch';
  y4patcthes(rr,:) = ones(length(rr),1) * Y(i,1);
  patchIdx(rr,:) = ones(length(rr),1) * i;
end